//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37177F27FC89.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37177F27FC89.cm

//## begin module%37177F27FC89.cp preserve=no
//## end module%37177F27FC89.cp

//## Module: ModParam%37177F27FC89; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ModParam.h

#ifndef MODPARAM_H
#define MODPARAM_H 1

//## begin module%37177F27FC89.additionalIncludes preserve=no
//## end module%37177F27FC89.additionalIncludes

//## begin module%37177F27FC89.includes preserve=yes
//## end module%37177F27FC89.includes

// ParamData
#include <XSModel/Parameter/ParamData.h>
// Parameter
#include <XSModel/Parameter/Parameter.h>
//## begin module%37177F27FC89.declarations preserve=no
//## end module%37177F27FC89.declarations

//## begin module%37177F27FC89.additionalDeclarations preserve=yes
#include "XSsymbol.h"
//## end module%37177F27FC89.additionalDeclarations


//## begin ModParam%3639F03B0399.preface preserve=yes
//## end ModParam%3639F03B0399.preface

//## Class: ModParam%3639F03B0399
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A06D2E603E3;std::ostream { -> }

class ModParam : public Parameter  //## Inherits: <unnamed>%38EB4EDCF508
{
  //## begin ModParam%3639F03B0399.initialDeclarations preserve=yes
  //## end ModParam%3639F03B0399.initialDeclarations

  public:
    //## begin ModParam::PriorType%421BA7CB0187.preface preserve=yes
    //## end ModParam::PriorType%421BA7CB0187.preface

    //## Class: PriorType%421BA7CB0187
    //## Category: XSModel::Parameter%36349D8902D7
    //## Subsystem: XSModel::Parameter%367691A8CEA0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {CONS, EXP} PriorType;

    //## begin ModParam::PriorType%421BA7CB0187.postscript preserve=yes
    //## end ModParam::PriorType%421BA7CB0187.postscript

    //## Constructors (generated)
      ModParam(const ModParam &right);

    //## Constructors (specified)
      //## Operation: ModParam%373B0D33FD80;      C++
      //	Custom Constructor
      ModParam (const string& inputName, ComponentBase* p, Real val, Real delta = 0., Real high = LARGE, Real low = -LARGE, Real top = LARGE, Real bot = -LARGE, const string& unit = string(), bool isPeriodic = false);

    //## Destructor (generated)
      virtual ~ModParam();


    //## Other Operations (specified)
      //## Operation: setValue%373B0D33FD89;             C++
      virtual int setValue (Real val, const char key = 'v');

      //## Operation: clone%3773E31D1598; C++
      virtual ModParam* clone (ComponentBase* p = 0) const;

      //## Operation: freeze%3911B45B6908
      virtual void freeze ();

      //## Operation: thaw%3911B4EC6000
      virtual void thaw ();

      //## Operation: limitsInvalid%3913323A44A0
      bool limitsInvalid ();

      //## Operation: value%3A92C7550155
      virtual Real value () const;

      //## Operation: limitsInvalid%3B7D51EC009F;         C++
      bool limitsInvalid () const;

      //## Operation: adjustedValue%3B7D51F00143;         C++
      Real adjustedValue () const;

      //## Operation: value%3B7D557400FE;         C++
      Real value (const char key) const;

      //## Operation: reset%3C10D5A3022A
      //	reset parameter value to its initial values.
      //
      //	This is a virtual function whose default implementation
      //	is to assume that the parameter is defined in XSPEC's
      //	model.{version} file.
      //## Exceptions: Parameter::ResetFailure
      virtual void reset () throw (Parameter::ResetFailure);

      //## Operation: peg%3C98CEFA020E
      void peg ();

      //## Operation: unpeg%3C98CF1201B7
      void unpeg ();

      //## Operation: stringVal%3CEC0072004F
      //	Operation supporting the XSPEC tclout command which
      //	simply writes the data members of the parameter to a
      //	string.
      virtual string stringVal () const;

      //## Operation: parameterSetting%3F2E79AF03AF
      virtual string parameterSetting () const;

      //## Operation: parseModParamString%471E26B3020B
      static void parseModParamString (const string& fullLine, string& parName, Real* pVal, Real* pDelta, Real* pHigh, Real* pLow, Real* pTop, Real* pBot, string& unit, bool* pIsPeriodic);

      //## Operation: getParameterLabel%4A0863B3017B
      //	Constructs a string from the model name and parameter
      //	index, useful for Fit output column headings.
      virtual string getParameterLabel () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: unit%373B0D33FD72
      //	]
      const string& unit () const;

      //## Attribute: isFrozen%3911B42A5A10
      virtual bool isFrozen () const;

      //## Attribute: epo%3B7D51870250
      Real epo () const;

      //## Attribute: emn%3B7D518C03D1
      Real emn () const;

      //## Attribute: epe%3B7D51930277
      Real epe () const;

      //## Attribute: gcc%3B7D519801E7
      Real gcc () const;

      //## Attribute: sigma%3B7D519D00E5
      Real sigma () const;

      //## Attribute: isPegged%3C98CECB00CB
      const bool isPegged () const;

      //## Attribute: priorType%421BA8A80079
      ModParam::PriorType priorType () const;
      void priorType (ModParam::PriorType value);

      //## Attribute: hyperParam%421BA91A0248
      Real hyperParam () const;
      void hyperParam (Real value);

      //## Attribute: lastErrorStatus%43468F7D009E
      const string& lastErrorStatus () const;
      void lastErrorStatus (const string& value);

      //## Attribute: isPeriodic%471E36150193
      bool isPeriodic () const;

  public:
    // Additional Public Declarations
      //## begin ModParam%3639F03B0399.public preserve=yes
      //## end ModParam%3639F03B0399.public

  protected:
    //## Constructors (specified)
      //## Operation: ModParam%471E39F30253
      //	Originally intended for use by ResponseParam subclass.
      //	Unit string and isPeriodic flag are fixed at their
      //	defaults, and ComponentBase parent pointer is fixed at
      //	NULL.
      ModParam (const string& initString);


    //## Other Operations (specified)
      //## Operation: compare%3773EC00F2C0; C++
      virtual bool compare (const Parameter& right) const;

      //## Operation: put%373B0D33FD9C;  C++
      virtual std::ostream& put (std::ostream& s) const;

      //## Operation: changeValue%38F641F7FFF0
      virtual void changeValue (const string& parString);

      //## Operation: doPreserve%3C0FD454023D
      virtual void doPreserve ();

      //## Operation: processValues%407C154701BB
      virtual bool processValues (const string& parString);

      //## Operation: rePrompt%407C15E40284
      virtual void rePrompt (string& newString) const;

      //## Operation: checkDeltaForFrozen%44E3594600C8
      Real checkDeltaForFrozen (Real delta);

      //## Operation: init%471E5C4802C9
      virtual void init (const string& initStr);

      //## Operation: applyPeriodicity%471F753A01F3
      Real applyPeriodicity (Real value) const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Parameter::<unnamed>%382C75422200
      //## Role: ModParam::values%382C75435118
      const ParamData values () const;
      void values (ParamData value);

    // Additional Protected Declarations
      //## begin ModParam%3639F03B0399.protected preserve=yes
      //## end ModParam%3639F03B0399.protected

  private:
    //## Constructors (generated)
      ModParam();

    //## Assignment Operation (generated)
      ModParam & operator=(const ModParam &right);

    // Additional Private Declarations
      //## begin ModParam%3639F03B0399.private preserve=yes
      //## end ModParam%3639F03B0399.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ModParam::unit%373B0D33FD72.attr preserve=no  public: string {UC} 
      const string m_unit;
      //## end ModParam::unit%373B0D33FD72.attr

      //## begin ModParam::isFrozen%3911B42A5A10.attr preserve=no  public: bool {U} false
      bool m_isFrozen;
      //## end ModParam::isFrozen%3911B42A5A10.attr

      //## begin ModParam::epo%3B7D51870250.attr preserve=no  public: Real {U} 0.
      Real m_epo;
      //## end ModParam::epo%3B7D51870250.attr

      //## begin ModParam::emn%3B7D518C03D1.attr preserve=no  public: Real {V} 0.
      Real m_emn;
      //## end ModParam::emn%3B7D518C03D1.attr

      //## begin ModParam::epe%3B7D51930277.attr preserve=no  public: Real {U} 0.
      Real m_epe;
      //## end ModParam::epe%3B7D51930277.attr

      //## begin ModParam::gcc%3B7D519801E7.attr preserve=no  public: Real {U} 0.
      Real m_gcc;
      //## end ModParam::gcc%3B7D519801E7.attr

      //## begin ModParam::sigma%3B7D519D00E5.attr preserve=no  public: Real {V} 0
      Real m_sigma;
      //## end ModParam::sigma%3B7D519D00E5.attr

      //## begin ModParam::isPegged%3C98CECB00CB.attr preserve=no  public: bool {U} false
      bool m_isPegged;
      //## end ModParam::isPegged%3C98CECB00CB.attr

      //## begin ModParam::priorType%421BA8A80079.attr preserve=no  public: ModParam::PriorType {U} 
      ModParam::PriorType m_priorType;
      //## end ModParam::priorType%421BA8A80079.attr

      //## begin ModParam::hyperParam%421BA91A0248.attr preserve=no  public: Real {U} 
      Real m_hyperParam;
      //## end ModParam::hyperParam%421BA91A0248.attr

      //## begin ModParam::lastErrorStatus%43468F7D009E.attr preserve=no  public: string {U} 
      string m_lastErrorStatus;
      //## end ModParam::lastErrorStatus%43468F7D009E.attr

      //## begin ModParam::isPeriodic%471E36150193.attr preserve=no  public: bool {UC} 
      const bool m_isPeriodic;
      //## end ModParam::isPeriodic%471E36150193.attr

    // Data Members for Associations

      //## Association: XSModel::Parameter::<unnamed>%382C75422200
      //## begin ModParam::values%382C75435118.role preserve=no  protected: ParamData {1..1 -> 1..1VHgN}
      ParamData m_values;
      //## end ModParam::values%382C75435118.role

    // Additional Implementation Declarations
      //## begin ModParam%3639F03B0399.implementation preserve=yes
      //## end ModParam%3639F03B0399.implementation

};

//## begin ModParam%3639F03B0399.postscript preserve=yes
//## end ModParam%3639F03B0399.postscript

// Class ModParam 


//## Other Operations (inline)
inline void ModParam::thaw ()
{
  m_isFrozen = false;

  //## begin ModParam::thaw%3911B4EC6000.body preserve=yes
  //## end ModParam::thaw%3911B4EC6000.body
}

inline bool ModParam::limitsInvalid () const
{
  //## begin ModParam::limitsInvalid%3B7D51EC009F.body preserve=yes
  return ( m_values.bot() > m_values.top() || 
           m_values.top() > m_values.max() ||
           m_values.min() > m_values.max() ); 
  //## end ModParam::limitsInvalid%3B7D51EC009F.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& ModParam::unit () const
{
  //## begin ModParam::unit%373B0D33FD72.get preserve=no
  return m_unit;
  //## end ModParam::unit%373B0D33FD72.get
}

inline bool ModParam::isFrozen () const
{
  //## begin ModParam::isFrozen%3911B42A5A10.get preserve=no
  return m_isFrozen;
  //## end ModParam::isFrozen%3911B42A5A10.get
}

inline Real ModParam::epo () const
{
  //## begin ModParam::epo%3B7D51870250.get preserve=no
  return m_epo;
  //## end ModParam::epo%3B7D51870250.get
}

inline Real ModParam::emn () const
{
  //## begin ModParam::emn%3B7D518C03D1.get preserve=no
  return m_emn;
  //## end ModParam::emn%3B7D518C03D1.get
}

inline Real ModParam::epe () const
{
  //## begin ModParam::epe%3B7D51930277.get preserve=no
  return m_epe;
  //## end ModParam::epe%3B7D51930277.get
}

inline Real ModParam::gcc () const
{
  //## begin ModParam::gcc%3B7D519801E7.get preserve=no
  return m_gcc;
  //## end ModParam::gcc%3B7D519801E7.get
}

inline Real ModParam::sigma () const
{
  //## begin ModParam::sigma%3B7D519D00E5.get preserve=no
  return m_sigma;
  //## end ModParam::sigma%3B7D519D00E5.get
}

inline ModParam::PriorType ModParam::priorType () const
{
  //## begin ModParam::priorType%421BA8A80079.get preserve=no
  return m_priorType;
  //## end ModParam::priorType%421BA8A80079.get
}

inline void ModParam::priorType (ModParam::PriorType value)
{
  //## begin ModParam::priorType%421BA8A80079.set preserve=no
  m_priorType = value;
  //## end ModParam::priorType%421BA8A80079.set
}

inline Real ModParam::hyperParam () const
{
  //## begin ModParam::hyperParam%421BA91A0248.get preserve=no
  return m_hyperParam;
  //## end ModParam::hyperParam%421BA91A0248.get
}

inline void ModParam::hyperParam (Real value)
{
  //## begin ModParam::hyperParam%421BA91A0248.set preserve=no
  m_hyperParam = value;
  //## end ModParam::hyperParam%421BA91A0248.set
}

inline const string& ModParam::lastErrorStatus () const
{
  //## begin ModParam::lastErrorStatus%43468F7D009E.get preserve=no
  return m_lastErrorStatus;
  //## end ModParam::lastErrorStatus%43468F7D009E.get
}

inline void ModParam::lastErrorStatus (const string& value)
{
  //## begin ModParam::lastErrorStatus%43468F7D009E.set preserve=no
  m_lastErrorStatus = value;
  //## end ModParam::lastErrorStatus%43468F7D009E.set
}

inline bool ModParam::isPeriodic () const
{
  //## begin ModParam::isPeriodic%471E36150193.get preserve=no
  return m_isPeriodic;
  //## end ModParam::isPeriodic%471E36150193.get
}

//## Get and Set Operations for Associations (inline)

inline const ParamData ModParam::values () const
{
  //## begin ModParam::values%382C75435118.get preserve=no
  return m_values;
  //## end ModParam::values%382C75435118.get
}

inline void ModParam::values (ParamData value)
{
  //## begin ModParam::values%382C75435118.set preserve=no
  m_values = value;
  //## end ModParam::values%382C75435118.set
}

//## begin module%37177F27FC89.epilog preserve=yes
//## end module%37177F27FC89.epilog


#endif
